unit ICButtonWhat;

interface

	uses
		ICWindowGlobals;

	function WhatOpenButton (wt: WindowType; item: integer): OSErr;
	function WhatClickButton (wt: WindowType; item: integer; er: eventRecord): OSErr;

implementation

	uses
		IconFamilies, ICStrH, 

		ICMappings, ICSubs, ICDialogs, ICMiscSubs, ICSubs, ICDocUtils, ICGlobals, ICWindowUtils;

	procedure GetIconRect (dlg: DialogPtr; item: integer; var r: Rect);
	begin
		GetDItemRect(dlg, item, r);
		r.right := r.left + 32;
		r.bottom := r.top + 32;
		OffsetRect(r, 2, 2);
	end; (* GetIconRect *)

	procedure UserItemUpdate (dlg: DialogPtr; item: integer);
		var
			r: Rect;
			font_info: FontInfo;
	begin
		GetIconRect(dlg, item, r);
		DrawIcon(200 + item, r);
		GetFontInfo(font_info);
		MoveTo(r.right + 4, ((r.bottom - r.top - font_info.ascent - font_info.descent) div 2) + r.top + font_info.ascent);
		DrawString(GetAString(130, item));
		GetDItemRect(dlg, item, r);
		FrameRoundRect(r, 10, 10);
	end; (* UserItemUpdate *)

	function WhatOpenButton (wt: WindowType; item: integer): OSErr;
	begin
		SetDItemHandle(windowinfo[wt].window, item, @UserItemUpdate);
		WhatOpenButton := noErr;
	end; (* WhatOpenButton *)

	function WhatClickButton (wt: WindowType; item: integer; er: eventRecord): OSErr;
		const
			HiliteMode = $938;
		var
			dlg: DialogPtr;
			r: Rect;
			highlighted: boolean;
			suite: Handle;
			junk: OSErr;
			transfer: integer;
			highlight_rgn: RgnHandle;
			tmp_rgn: RgnHandle;
			icon_rect: Rect;
			mouse_pos: Point;

		procedure ToggleHighlight;
		begin
			highlighted := not highlighted;
			if system7 then begin
				if highlighted then begin
					transfer := ttSelected;
				end
				else begin
					transfer := ttNone;
				end; (* if *)
				junk := PlotIconSuite(icon_rect, atNone, transfer, suite);
			end; (* if *)
			if has_colorQD then begin
				BitClr(Ptr(HiliteMode), pHiliteBit);
			end; (* if *)
			InvertRgn(highlight_rgn);
		end; (* ToggleHighlight *)

		var
			err: OSErr;
	begin
		dlg := windowinfo[wt].window;
		GetIconRect(dlg, item, icon_rect);
		GetDItemRect(dlg, item, r);
		suite := nil;
		highlight_rgn := NewRgn;
		RectRgn(highlight_rgn, r);
		if system7 then begin
			junk := GetIconSuite(suite, 200 + item, svAllLargeData);
			tmp_rgn := NewRgn;
			junk := IconSuiteToRgn(tmp_rgn, icon_rect, atNone, suite);
			XorRgn(tmp_rgn, highlight_rgn, highlight_rgn);
			DisposeRgn(tmp_rgn);
		end; (* if *)
		highlighted := false;
		while StillDown do begin
			GetMouse(mouse_pos);
			if PtInRect(mouse_pos, r) <> highlighted then begin
				ToggleHighlight;
			end; (* if *)
		end; (* while *)
		err := noErr;
		if highlighted then begin
			ToggleHighlight;
			err := WindowsOpen(WindowType(ord(WT_Personal) + item - 1), 200 + item);
		end; (* if *)
		if suite <> nil then begin
			junk := DisposeIconSuite(suite, false);
		end; (* if *)
		if highlight_rgn <> nil then begin
			DisposeRgn(highlight_rgn);
		end; (* if *)
		WhatClickButton := err;
	end; (* WhatClickButton *)

end. (* ICButtonWhat *)